<?php
/**
 * SMS gateway for HopeBilling via service AlphaSMS.ua
 *
 * Created by PhpStorm.
 * Author: mrinmiro@gmail.com
 * Date: 09.05.18
 * Time: 13:13
 */

namespace sms;

use SoapClient;
use System\Config;

class AlphaSMS implements ISMS
{
    protected $client = null;

    public function __construct()
    {
        // $this->client = new SoapClient('https://alphasms.ua/api/soap.php?wsdl');
    }

    public function sendSMS($to, $text)
    {
        $smsconfig = new Config('sms-gateway');
		
		if (empty($smsconfig->alphasms->login) || empty($smsconfig->alphasms->password)) {
			return false;
		}
		
		$to = preg_replace("/[^0-9]/", '', $to);
		
		$url = 'https://alphasms.ua/api/http.php?version=http' . 
			'&login=' . $smsconfig->alphasms->login . 
			'&password=' . $smsconfig->alphasms->password . 
			'&command=send' . 
			'&from=' . $smsconfig->alphasms->sender . 
			'&to=' . $to . 
			'&message=' . urlencode($text);
		
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
		$this->result = curl_exec($ch);
		curl_close($ch);

        return !empty($this->result);
    }

}